package grouptool.tatool;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import jscheme.*;
import silk.*;

public class PlainDocumentWrapper extends PlainDocument {

    Procedure insertProc, deleteProc;

    public PlainDocumentWrapper(Procedure insertProc, Procedure deleteProc){
	super();
	this.insertProc = insertProc;
	this.deleteProc = deleteProc;
    }

    public synchronized void insertString(int offset, String str, AttributeSet a) throws BadLocationException {
	if ((insertProc != null) &&
            (!(Boolean.FALSE.equals(SI.apply(insertProc, SI.list(new Integer(offset), str, a))))))
	    super.insertString(offset, str, a);
    }


    public synchronized void insertStringNoSend(int offset, String str, AttributeSet a, Procedure p) throws BadLocationException {
        super.insertString(offset,str,a);
	SI.apply(p, SI.list(new Integer(offset), str, a));
    }

    public synchronized void remove(int offset, int len) throws BadLocationException {
	Segment s = new Segment();
        this.getText(offset,len,s);
	if ((insertProc != null)  &&
            (!(Boolean.FALSE.equals(SI.apply(deleteProc, SI.list(new Integer(offset),new Integer(len),s))))))
	    super.remove(offset, len);
    }


    public synchronized void removeNoSend(int offset, int len,Procedure p) throws BadLocationException {
	Segment s = new Segment();
        this.getText(offset,len,s);
        super.remove(offset,len);
	SI.apply(p, SI.list(new Integer(offset),new Integer(len),s));
    }
}
