;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; groupanalyze.scm
;; 1/26/2002
;; Tim Hickey
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; uncomment this and comment out next two if you don't want to transfrom files
;(define output (lambda R #t))

(define xforming #t)  ; set to false if not transforming
(define logfile (open-output-file "xformed.log"))
(define output  
    (lambda R (display (jscheme.REPL.printToString R  #t) logfile) (newline logfile)))



(jlib.Swing.load)
;; this requires tat/GenericFileMenu.scm and tat/FileMenu.scm
(define maketagger 
  (let ((maketagger maketagger))
    (lambda ()
      (let ((T (maketagger)))
        (lambda R
           (tryCatch (apply T R)
             (lambda (e) (display (list "Error in tagger args " R)) #null)))))))


 
(define (r) (load "groupanalyze.scm"))



  (define (update-scroller)
    (let ((L (.length (.getText (vcr "chat-panel")))))
          (tryCatch (.setCaretPosition (vcr "chat-panel") (+ -1 L)) (lambda(e) #t))))

  (define (update-scroller2)
        (let* ((vp (.getViewport (vcr "chatscroll")))
               (size (.getViewSize vp))
               (p (java.awt.Point. 0 (.intValue(.getHeight size)))))
         (.setViewPosition vp p)))


  (define vcr (maketagger))


  (define (load-log filename)
    (define (read-in in L) 
      (let ((x (read in)))
        (if (eof-object? x) L (read-in in (cons x L)))))
    (define in (open-input-file filename))
    (define L1 (read-in in ()))
    (define L (reverse L1))
    (let ((start (caar L))
          (end (caar L1)))
       (vcr "start" start)
       (vcr "end" end)
       (vcr "log" L)
       L))

  ;; state variables
  (define stop #f)
  (define pause #f)
  (define speedup 1)
  (define direction 'forward)

  ;; vcr view of the tool
  (define remotecolor (color 200 200 255))

  (define vcrscreen (vcr "screen"
   (window 
    (border
   (center
    (vcr "h0"
    (vsplit 200    
     (vcr "h1"
      (hsplit 75
        (border (north (label "Assignment")) (center
          (vcr "first" (scrollpane (vcr "stcomm" (textarea 10 20 remotecolor))))))
       (vcr "h2" (hsplit 250
        (border
          (north (label "student program")) 
          (center
            (vcr "second" (scrollpane (vcr "stprog" (textarea 10 20 remotecolor)
                       )))))
        (border (north  (label "Resources")) (center
          (vcr "third" (scrollpane (vcr "tacomm" (textarea 10 20))))))))))
    (vcr "chats"
     (hsplit 150
        (vcr "wbpanel" (grouptool.tatool.JSchemePanel. 300 350))
        (vcr "chatscroll"
          (scrollpane (vcr "chat-panel" (textarea  10 50)))))))))))))


  (define red-highlight-list '(0 0))
  (define green-highlight-list '(0 0))
  (define blue-highlight-list '(0 0))


  (define (make-highlighter-both the-textarea)
    (let ((highlighter (.getHighlighter the-textarea))
          (greenhighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. green))
          (bluehighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. cyan))
          (redhighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. red))
          (tail 10)
   )
    
   (lambda (the-time greenoffset blueoffset)
    
    (.removeAllHighlights highlighter)   
    (let* ((P the-textarea)
           (gb (list green-highlight-list (list (max 0 (- greenoffset tail)) greenoffset)
                      blue-highlight-list (list (max 0 (- blueoffset tail)) blueoffset)))     )

     
      (if (< (- (max greenoffset blueoffset) (min greenoffset blueoffset)) tail)
          (begin
             (apply output  
               (append 
                 (list the-time 'stprog 'highlight 'rrggbb red-highlight-list 
                        (list (max 0 (- (max greenoffset blueoffset) tail))
                              (min greenoffset blueoffset)))
                 gb))
             (set! red-highlight-list 
                (list (- (max greenoffset blueoffset) tail)
                      (min greenoffset blueoffset)))
             (.addHighlight highlighter 
		 (- (max greenoffset blueoffset) tail)
		 (min greenoffset blueoffset)
		 redhighlights))
         (apply output (append (list the-time 'stprog 'highlight 'rrggbb red-highlight-list '(0 0)) gb)))


      (set! green-highlight-list (list (max 0 (- greenoffset tail)) greenoffset))
      (.addHighlight highlighter 
	(max 0 (- greenoffset tail))
	 greenoffset
	 greenhighlights)

      (set! blue-highlight-list (list (max 0 (- blueoffset tail)) blueoffset))
      (.addHighlight highlighter 
	(max 0 (- blueoffset tail))
	blueoffset
	bluehighlights)
  ))))



  (define highlight (make-highlighter-both (vcr "stprog")))
  (define greenoffset 0)
  (define blueoffset 0)

  ;; this is the procedure that actually handles each line in the
  ;; log file. The lines all have the form:
  ;;  the-time net-type in/out port message
  ;;  long     symbol   object int  list/string

  (define (update-vcr the-time net-type in/out port message)
    (if (and 
          (equal? net-type 'group) 
          (equal? in/out 'in)
          (pair? message)
          (pair? (first message)))
    (let* (
       (x (first message))
       (where (first x))   ;; tacomm, stcomm, or stprog
       (action (second x)) ;; insert, delete
       (what (third x))    ;; shared-textarea
          )
     (case action
       ((insert delete) #t) ;; ignore these

       ((modify-highlights)
        (let* ((data (rest message))
               (insoffset (first data))
               (inscolor (second data))
               (len (third data)))
           (if (equal? inscolor 'green)
		  (begin
		    (set! greenoffset (+ insoffset len))
		    (if (> blueoffset insoffset)
			  (set! blueoffset (+ blueoffset len))))
		  (begin
		    (set! blueoffset (+ insoffset len))
		    (if (> greenoffset insoffset)
			(set! greenoffset (+ greenoffset len)))))
;              (output the-time 'highlight greenoffset blueoffset)
	      (highlight the-time greenoffset blueoffset)))


       ((logger)
         (let* ((data (rest (rest message))) ;; start-point ins/del-text size-of-ins/del 
                (offset (first data))
                (str (second data))
                (len (third data))
               )
          (case (second message)
            ((insert)
              (display (list '.insertString where offset str))(newline)
              (output the-time where 'insert offset str (.length str) (list-ref data 3))
              (.insertString (.getDocument (vcr (.toString where))) offset str #null))
            ((delete)
              (display (list '.remove where offset len))(newline)
              (let ((str (.getText (.getDocument (vcr (.toString where))) offset len) ))
                  (output the-time where 'remove offset str (.length str) (list-ref data 3)))
              (.remove (.getDocument (vcr (.toString where))) offset len))
            (else 
               (display (list "ERROR in update-vcr:unknown action" action the-time net-type in/out port message))
               (newline)))))
       (else (display (list "ERROR in update-vcr:unknown action" action the-time net-type in/out port message))
              (newline)))))


    (if (and 
          (equal? net-type 'servent) 
          (equal? in/out 'in)
          (string? (first message)))
       (begin
        (output the-time 'chat-panel 'in (first message) (second message))
        (.append (vcr "chat-panel")
             (string-append (first message) "\n" (second message) "\n")))
        (update-scroller))

    (if (and 
          (equal? net-type 'servent) 
          (equal? in/out 'out)
          (equal? 'send (first message))
          (string? (third message))
         )
       (begin
        (output the-time 'chat-panel 'out (first (cddr message)) (second (cddr message)))
        (.append (vcr "chat-panel")
             (string-append (first (cddr message)) "\n" (second (cddr message)) "\n")))
        (update-scroller))

    (if (and
          (equal? net-type 'group) 
          (equal? in/out 'in)
          (pair? message)
          (equal? 'abc (first message)))
     (begin
       (output the-time 'whiteboard  message)
       (whiteboard-action message)))
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;              VCR CONTROLLER WINDOW
;;
;; This is a little messy because we want to use a file open/save dialog
;; in the file menu, but this requires a reference to the parent window
;; which is in the process of being created.....
;; None of this would be necessary if we could pass a function returning a
;; parent window into the Dialog window constructor....
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 (define (reset-vcr)
 ;; stop all paused or running threads
    (set! stop #t) 
    (java.lang.Thread.sleep 500L) 
 ;; reset stop/pause
    (set! stop #f) 
    (set! pause #f)
    (writeexpr (vcr "pausebutton") "pause")
 ;; reset whiteboard
    (.setColor (.bufferg$ (vcr "wbpanel")) white)
    (.fillRect (.bufferg$ (vcr "wbpanel")) 0 0 1000 1000)
    (.repaint (vcr "wbpanel"))
    (set! greenoffset 0)
    (set! blueoffset 0)
    (highlight (first (first (vcr "log"))) 0 0)
 ;; reset vcrscreen view
    (map        
      (lambda(x) (writeexpr (vcr x) "")) 
      (list "stcomm" "tacomm" "stprog" "chat-panel")))

 (define stepmode #f)

 (define vcrwin  
  (let (
     (win  
       (window "VCR" white
        (menubar
          (vcr "filemenu" (menu "File" )) white)
        (border
         (north (vcr "filedata" (label "-----------------------------" white)))
         (south
           (table 5 2
             (vcr "the-time" (label "--------------------------------------------------" white))
               (vcr "speedup" (choice "1" "2" "3" "4" "5" "10" "100" "1000" "1000000" white (action (lambda(e)
                 (set! speedup (readexpr (vcr "speedup")))))))

             (button "start" green (action (lambda(e) 
                          ;; first, we must kill any paused threads! 
                (reset-vcr)
                (.start (java.lang.Thread. (lambda() (play (first (vcr "log")) (rest (vcr "log")))))))))
             
               (button "stop" red (action (lambda(e) (reset-vcr))))

             (button "pause" yellow
               (lambda(this) (vcr "pausebutton" this)) ;; bind "pausebutton" to this button
               (action (lambda(e) 
                (if pause 
                   (begin (writeexpr (vcr "pausebutton") "pause") (set! pause #f))
                   (begin (writeexpr (vcr "pausebutton") "continue") (set! pause #t))))))

              (button "step" (action (lambda(e) (set! stepmode #t))))

             (vcr "status" (label "--------------------------------------------------" white))

             white ;; for table
          ))white  ;; for border
         )))
      (menu-controller
         (lambda (command . Args) 
          (tryCatch
           (case command
             ((string-to-save) (string-append (list (vcr "logfile") "\n" (vcr "bookmarks"))))
             ((parent-win) (vcr "win"))
             ((quit) (.hide vcrwin) (.hide vcrscreen))
             ((new open) 
                 (if (equal? command 'new)
                    (begin
                        (vcr "filename" "default.ana") 
                        (vcr "logfile" (get-new-log-file))
                        (vcr "bookmarks" ()))
                    (begin
                        (vcr "filename" (.getName (first Args)))
                        (vcr "logfile" (first (second Args)))
                        (vcr "bookmarks" (second (second Args)))))
                   (load-log (vcr "logfile")) (display (list "loading log")) (newline)
                   (writeexpr (vcr "filedata") 
                    (string-append (vcr "filename") " / "
                     (* 0.001 (- (vcr "end") (vcr "start"))) " seconds/ "
                     (length (vcr "log")) " events/ "
                     (java.util.Date. (vcr "start")) ": start time"
                    ))
                   ; handle bookmarks ....
                 ))
             (lambda(e) 'abort-menu-action)) ;; this inelegantly handles the case of selecting "cancel"
        ))
     ) ; end of let

   ;; now we add the file menu
    (addFileMenuItems (vcr "filemenu") win menu-controller)
   ;; and return the fully constructed window
    win
  ))


 ;; this lets the user select a new raw log data file
 (define get-new-log-file
  (let ((FileDialogLoad 
        (java.awt.FileDialog. vcrwin "Select Raw Log File" java.awt.FileDialog.LOAD$)))
   (lambda ()
      (.show FileDialogLoad)
      (.getAbsolutePath (java.io.File. (.getDirectory FileDialogLoad) (.getFile FileDialogLoad)))
   )))

    




  (define (play X L)
   (let (
         (the-time (first X))
         (net-type (second X))
         (in/out (third X))
         (port (list-ref X 3))
         (message (list-ref X 4)))

      (if (or (null? L) stop)
          (begin
             (if xforming (.close logfile))
             'done)
         (if pause
          (let loop() 
              (java.lang.Thread.sleep 100L) 
              (if stop 'done
                 (if pause (loop) 
                    (play X L))))
          (let* (
              (y (first L))
              (y-time (first y))
              (real-delay (- y-time the-time))
              (delay (/ real-delay speedup))
                )
            (tryCatch (update-vcr the-time net-type in/out port message)
                 (lambda(e) (display (list "error in update-vcr:" e))(newline)))
            (sleep-and-show-clock the-time real-delay speedup (length L))
            (play y (rest L)))))))


    (define (sleep-and-show-clock the-time real-delay speedup Len)
       (writelnexpr (vcr "the-time") (java.util.Date. the-time))
       (writelnexpr (vcr "status") Len)
      
       (if (< real-delay 1000)
             (if (>= real-delay 0)
                 (java.lang.Thread.sleep (.longValue (/ real-delay speedup)))
                 (display (list "SLEEP ERROR: " the-time real-delay speedup)))
           (if stepmode 
             (set! stepmode #f)
             (begin
              (java.lang.Thread.sleep (.longValue (/ 1000 speedup)))
              (sleep-and-show-clock (+ 1000 the-time) (- real-delay 1000) speedup Len)))))
            
      


    (define (listener leader follower1 follower2)
	(Listener. (lambda(e)
		     (.setValue follower1 (.getValue leader))
		     (.setValue follower2  (.getValue leader))
                   )))

    (vcr "first-scroll" (.getVerticalScrollBar (vcr "first")))
    (vcr "second-scroll"(.getVerticalScrollBar (vcr "second")))
    (vcr "third-scroll" (.getVerticalScrollBar (vcr "third")))

    (.addAdjustmentListener (vcr "second-scroll") (listener (vcr "second-scroll") (vcr "second-scroll") (vcr "third-scroll")))
    (.addAdjustmentListener (vcr "first-scroll") (listener (vcr "first-scroll") (vcr "first-scroll") (vcr "third-scroll")))
    (.addAdjustmentListener (vcr "third-scroll") (listener (vcr "third-scroll") (vcr "second-scroll") (vcr "first-scroll")))



 (define (string->color S)
  (case S
   (("red") (color 255 0 0))
   (("green") (color 0 255 0))
   (("blue") (color 0 0 255))))

(define (drawToGraphics graphics laststring currentstring color lastx lasty)
    (.setColor graphics white)
    (.drawString graphics laststring lastx lasty)
    (.setColor graphics (string->color color))
    (.drawString graphics  currentstring lastx lasty)
)


 (define (whiteboard-action R)
 (case (second R)
  ((text) 
    (let (
	  ;(g (.getGraphics (vcr "wbpanel")))
          (lastx (list-ref R 3))
          (lasty (list-ref R 4))
          (laststring (list-ref R 5))
          (current (list-ref R 6))
          (color (list-ref R 7))
         )
     (drawToGraphics (.bufferg$ (vcr "wbpanel")) laststring current color lastx lasty) 
     (.repaint (vcr "wbpanel"))
            
   ))

  ((free)
    (let (
	  ;(g (.getGraphics (vcr "wbpanel")))
	  )
      (.setColor (.bufferg$ (vcr "wbpanel")) (string->color (list-ref R 7)))
      (.drawLine (.bufferg$ (vcr "wbpanel"))  (list-ref R 3) (list-ref R 4) (list-ref R 5) (list-ref R 6))
      (.repaint (vcr "wbpanel"))
   ))

  ((line)
   (let (
	 ;(g (.getGraphics (vcr "wbpanel")))
	 )
     (.setColor (.bufferg$ (vcr "wbpanel")) (string->color (list-ref R 7)))
     (.drawLine (.bufferg$ (vcr "wbpanel")) (list-ref R 3) (list-ref R 4) (list-ref R 5) (list-ref R 6))
     (.repaint (vcr "wbpanel"))))

   ((rect)
   (let (
	 ;(g (.getGraphics (vcr "wbpanel")))
	 )
     (.setColor (.bufferg$ (vcr "wbpanel")) (string->color (list-ref R 7)))
     (.drawRect (.bufferg$ (vcr "wbpanel")) (list-ref R 3) (list-ref R 4) (list-ref R 5) (list-ref R 6))
     (.repaint (vcr "wbpanel"))))

   ((cursor)
    (let (
	  (g (.getGraphics (vcr "wbpanel")))
	  )
         (.setXORMode g white)
         (.setColor g(.darker (string->color (list-ref R 7))))
         (.drawOval g (+ -5 (list-ref R 3)) (+ -5 (list-ref R 4)) 10 10)
         (.drawOval g (+ -5 (list-ref R 5)) (+ -5 (list-ref R 6)) 10 10)
	 (.setPaintMode g)))
         

   ((startend-cursor)
    (let (
	  (g (.getGraphics (vcr "wbpanel")))
	  )
         (.setXORMode g white)
         (.setColor g (.darker (string->color (list-ref R 5))))
         (.drawOval g (+ -5 (list-ref R 3)) (+ -5 (list-ref R 4)) 10 10)
         (.setPaintMode g)))



  (else (display (list "we need some integration!!!" R))(newline))))



   (.pack vcrscreen)
   (.show vcrscreen)

   (.pack vcrwin)
   (.show vcrwin)


