(load "jlib/Swing.scm")
(load "../tat/HtmlFrame.scm")

(define (make-grouphw-model)
  (define vcr (maketagger))
  (define remotecolor (color 200 200 255))
  (define vcrscreen (vcr "screen"
   (window 
    (border
   (center
    (vcr "h0"
    (vsplit 200    
     (vcr "h1"
      (hsplit 75
        (border (north (label "Assignment")) (center
          (vcr "first" (scrollpane (vcr "first" (vcr "stacomm" 
            (htmlpane 'url "http://www.cs.brandeis.edu/~psyc/wdt/assignment2.html")))))))
       (vcr "h2" (hsplit 250
        (border
          (north (label "student program")) 
          (center
            (vcr "second" (scrollpane (vcr "stprog" (textarea 10 20 remotecolor)
                       )))))
        (border (north  (label "Resources")) (center
            (vcr "third" (vcr "tacomm" 
                 (htmlpane  'url "http://jscheme.sourceforge.net/jscheme/doc/jlib.html")))))))))
    (vcr "chats"
     (hsplit 150
        (vcr "wbpanel" (grouptool.tatool.JSchemePanel. 300 350))
        (vcr "chatscroll"
          (scrollpane (vcr "chat-panel" (textarea  10 50)))))))))))))

   vcr
)





(define (make-grouphw-handler vcr)

  (define modify-highlight
    (let ((highlighter (.getHighlighter (vcr "stprog")))
          (greenhighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. green))
          (bluehighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. cyan))
          (redhighlights (javax.swing.text.DefaultHighlighter$DefaultHighlightPainter. red)))

   (lambda (newred newgreen newblue)
    (.removeAllHighlights highlighter)   
    (if (> (second newred) (first newred))
      (.addHighlight highlighter (first newred)   (second newred)   redhighlights))
    (if (> (second newgreen) (first newgreen))
      (.addHighlight highlighter (first newgreen) (second newgreen) greenhighlights))
    (if (> (second newblue) (first newblue))
      (.addHighlight highlighter (first newblue)  (second newblue)  bluehighlights))
   )))

  
  (define end-chat-pos (.getEndPosition (.getDocument (vcr "chat-panel"))))

  (define (chat-writer event args)
      (.append (vcr "chat-panel") 
     {[(if (equal? event 'out) "[SELF]" "")] [(first args)]: [(second args)]\n})
      (tryCatch (.setCaretPosition (vcr "chat-panel") (max 0 (+ -1 (.getOffset end-chat-pos)))) (lambda(e) #t)))

  (define (chat-eraser event args)
     (let ((N (.length {[(if (equal? event 'out) "[SELF]" "")] [(first args)]: [(second args)]\n})))
           (.remove (.getDocument (vcr "chat-panel")) (- (.getOffset end-chat-pos) (+ 1 N)) N)
           (tryCatch (.setCaretPosition (vcr "chat-panel") (max 0 (+ -1 (.getOffset end-chat-pos)))) (lambda(e) #t))))

  (define (insert-text pos str len the-color) 
     (.insertString (.getDocument (vcr "stprog")) pos str #null)
     #t)
  (define (delete-text pos str len the-color)
     (.remove (.getDocument (vcr "stprog")) pos len)
     #t)
  (define (highlight rrggbb Rold Rnew Gold Gnew Bold Bnew)
     (modify-highlight Rnew Gnew Bnew)
     #t)
  (define (unhighlight rrggbb Rold Rnew Gold Gnew Bold Bnew)
     (modify-highlight Rold Gold Bold)
     #t)

  (let ((direction 'forward))
     (lambda (context event . args)

      (if (equal? event 'set)
       (case (first args)
             ((direction) (set! direction (second args)))
             (else #t))
       (case context
        ((stprog)
          (case event
            ((insert) 
               (case direction
                 ((forward) (apply insert-text args))
                 ((backward) (apply delete-text args))))
            ((remove) 
               (case direction
                 ((forward) (apply delete-text args))
                 ((backward) (apply insert-text args))))
            ((highlight)
               (case direction
                 ((forward)  (apply highlight args))
                 ((backward) (apply unhighlight args))))

            (else (display (list "error in handler" context event args)))))

      ((whiteboard) ;; we ignore these for now!
          #t)

      ((chat-panel) ;; ignore for now
        (case event
          ((in out)
             (case direction
               ((forward)
                  (chat-writer event args))
               ((backward)
                  (chat-eraser event args))))
          (else #f)))

      (else #t))))))

(define vcr (make-grouphw-model))
(define H (make-grouphw-handler vcr))
(define V (make-vcr 'handler H))

(.pack (vcr "screen"))
(.show (vcr "screen"))
(.pack (V 'get 'controller))
(.show (V 'get 'controller))

(let* ((controllerheight (.getHeight (V 'get 'controller)))
      (screensize (.getScreenSize (java.awt.Toolkit.getDefaultToolkit)))
      (sheight (.intValue (.getHeight screensize)))
      (swidth (.intValue (.getWidth screensize))))
  (.setLocation (vcr "screen") 0 0)
  (.resize (vcr "screen") (.intValue (.getWidth screensize)) 
           (.intValue (- (.getHeight screensize) (+ 30 controllerheight))))
  (.setLocation (V 'get 'controller) 0 (.intValue (- (.getHeight screensize) controllerheight)))
  (.resize (V 'get 'controller) (.intValue (.getWidth screensize)) (.intValue controllerheight))
  
  (display (list "setting h0 to " (/ (* 7 (- sheight controllerheight)) 10))) (newline)
  (Thread.sleep 1000L)
  (.setDividerLocation (vcr "h0") (/ (* 7 (- sheight controllerheight)) 10))
  
  (display (list "setting h1 to " (/ swidth 10)))(newline)
  (Thread.sleep 1000L)
  (.setDividerLocation (vcr "h1") (/ swidth 10))
  
  (display (list "setting h2 to " (/ (* swidth 8) 10)))(newline)
  (Thread.sleep 1000L)
  (.setDividerLocation (vcr "h2") (/ (* swidth 8) 10))
  
  (display (list "setting chats to " (/ swidth 2))) (newline)
  (Thread.sleep 1000L)
  (.setDividerLocation (vcr "chats") (/ swidth 2))

)



