(load "jlib/Swing.scm")

(define vcr (maketagger))

(define (load-log filename)
    (define (read-in in L) 
      (let ((x (read in)))
        (if (eof-object? x) L (read-in in (cons x L)))))
    (define in (open-input-file filename))
    (define L1 (read-in in ()))
    (define L (reverse L1))
    (let ((start (caar L))
          (end (caar L1)))
       (vcr "start" start)
       (vcr "end" end)
       (vcr "log" L)
       (length L)))

(define (runit)
  (play (first (vcr "log")) (rest (vcr "log"))))




  (define (play X L)
   (let (
         (the-time (first X))
         (net-type (second X))
         (in/out (third X))
         (port (list-ref X 3))
         (message (list-ref X 4)))

      (if (null? L)
          'done
          (let* (
              (y (first L))
              (y-time (first y))
                )
            (tryCatch (update-vcr the-time net-type in/out port message)
                 (lambda(e) (display (list "error in update-vcr:" e))(newline)))
            (play y (rest L))))))


  (define logfile (open-output-file "xformed.log"))
  (define output  (lambda R (display (jscheme.REPL.printToString R  #t) logfile) (newline logfile)))
  (define greenoffset 0)
  (define blueoffset 0)

  (define (update-vcr the-time net-type in/out port message)
    (if (and 
          (equal? net-type 'group) 
          (equal? in/out 'in)
          (pair? message)
          (pair? (first message)))
    (let* (
       (x (first message))
       (where (first x))   ;; tacomm, stcomm, or stprog
       (action (second x)) ;; insert, delete
       (what (third x))    ;; shared-textarea
          )
     (case action
       ((insert delete) #t) ;; ignore these

       ((modify-highlights)
        (let* ((data (rest message))
               (insoffset (first data))
               (inscolor (second data))
               (len (third data)))
           (if (equal? inscolor 'green)
		  (begin
		    (set! greenoffset (+ insoffset len))
		    (if (> blueoffset insoffset)
			  (set! blueoffset (+ blueoffset len))))
		  (begin
		    (set! blueoffset (+ insoffset len))
		    (if (> greenoffset insoffset)
			(set! greenoffset (+ greenoffset len)))))
	      (output the-time 'highlight greenoffset blueoffset)))


       ((logger)
         (let* ((data (rest (rest message))) ;; start-point ins/del-text size-of-ins/del 
                (offset (first data))
                (str (second data))
                (len (third data)))
          (case (second message)
            ((insert)
;              (display (list '.insertString where offset str))(newline)
              (output the-time 'insertstring where offset str))
            ((delete)
;              (display (list '.remove where offset len))(newline)
              (output the-time 'remove where offset len))
            (else 
               (display (list "ERROR in update-vcr:unknown action" action the-time net-type in/out port message))
               (newline)))))
       (else (display (list "ERROR in update-vcr:unknown action" action the-time net-type in/out port message))
              (newline)))))


    (if (and 
          (equal? net-type 'servent) 
          (equal? in/out 'in)
          (string? (first message)))
       (output the-time 'chat-panel 'in  (first message) (second message)))

    (if (and 
          (equal? net-type 'servent) 
          (equal? in/out 'out)
          (equal? 'send (first message))
          (string? (third message))
         )
       (output the-time 'chat-panel 'out (first (cddr message)) (second (cddr message))))

    (if (and
          (equal? net-type 'group) 
          (equal? in/out 'in)
          (pair? message)
          (equal? 'abc (first message)))
       (output the-time 'whiteboard-action message))
  )




